package com.benyanyi.okhttp;

import android.app.Application;
import android.content.Context;

import com.benyanyi.okhttp.config.HttpRequest;
import com.benyanyi.okhttp.type.RequestType;
import com.benyanyi.okhttp.util.FormatUtil;

import java.io.File;
import java.lang.reflect.InvocationTargetException;

/**
 * @author YanYi
 * @date 2019-08-02 22:22
 * @email ben@yanyi.red
 * @overview
 */
public class OkHttpUtil {

    private static OkHttpUtil instance;

    public static File cacheFile;

    public static OkHttpUtil getInstance() {
        if (instance == null) {
            instance = new OkHttpUtil();
        }
        return instance;
    }

    public RequestType url(String url) {
        if (FormatUtil.isEmpty(url) || (url.indexOf("https:") != 0 && url.indexOf("http:") != 0)) {
            throw new RuntimeException("url is not http or https");
        }
        return new HttpRequest(getApplication(), url, false);
    }

    public RequestType url(Context context, String url) {
        if (FormatUtil.isEmpty(url) || (url.indexOf("https:") != 0 && url.indexOf("http:") != 0)) {
            throw new RuntimeException("url is not http or https");
        }
        return new HttpRequest(context, url, false);
    }

    public RequestType url(String url, boolean isCache) {
        if (FormatUtil.isEmpty(url) || (url.indexOf("https:") != 0 && url.indexOf("http:") != 0)) {
            throw new RuntimeException("url is not http or https");
        }
        return new HttpRequest(getApplication(), url, isCache);
    }

    public RequestType url(Context mContext, String url, boolean isCache) {
        if (FormatUtil.isEmpty(url) || (url.indexOf("https:") != 0 && url.indexOf("http:") != 0)) {
            throw new RuntimeException("url is not http or https");
        }
        return new HttpRequest(mContext, url, isCache);
    }

    private Application getApplication() {
        Application application;
        try {
            application = (Application) Class.forName("android.app.ActivityThread").getMethod("currentApplication").invoke(null, (Object[]) null);
        } catch (IllegalAccessException e) {
            throw new RuntimeException(e);
        } catch (InvocationTargetException e) {
            throw new RuntimeException(e);
        } catch (NoSuchMethodException e) {
            throw new RuntimeException(e);
        } catch (ClassNotFoundException e) {
            throw new RuntimeException(e);
        }
        return application;
    }

}
