package com.benyanyi.okhttp.download;

import java.io.File;

/**
 * @author BenYanYi
 * @date 2018/11/29 15:18
 * @email ben@yanyi.red
 * @overview
 */
public class DownloadInfo {

    /**
     * 下载状态
     */
    public static final String DOWNLOAD_ING = "download_ing";    // 下载中
    public static final String DOWNLOAD_PAUSE = "download_pause"; // 下载暂停
    public static final String DOWNLOAD_WAIT = "download_wait";  // 等待下载
    public static final String DOWNLOAD_CANCEL = "download_cancel"; // 下载取消
    public static final String DOWNLOAD_OVER = "download_over";    // 下载结束
    public static final String DOWNLOAD_ERROR = "download_error";  // 下载出错

    /**
     * 获取进度失败
     */
    public static final long TOTAL_ERROR = -1;
    private String url;
    private long total;
    private long progress;
    private String fileName;
    private File file;
    private String downloadStatus;

    public DownloadInfo(String url) {
        this.url = url;
    }

    public String getUrl() {
        return url;
    }

    public String getFileName() {
        return fileName;
    }

    public void setFileName(String fileName) {
        this.fileName = fileName;
    }

    public long getTotal() {
        return total;
    }

    public void setTotal(long total) {
        this.total = total;
    }

    public long getProgress() {
        return progress;
    }

    public void setProgress(long progress) {
        this.progress = progress;
    }

    public File getFile() {
        return file;
    }

    public void setFile(File file) {
        this.file = file;
    }

    public String getDownloadStatus() {
        return downloadStatus;
    }

    public void setDownloadStatus(String downloadStatus) {
        this.downloadStatus = downloadStatus;
    }

    @Override
    public String toString() {
        return "DownloadInfo{" +
                "url='" + url + '\'' +
                ", total=" + total +
                ", progress=" + progress +
                ", fileName='" + fileName + '\'' +
                ", file=" + file +
                ", downloadStatus='" + downloadStatus + '\'' +
                '}';
    }
}
